/*  $Header: /home/cvsroot/dvipdfmx/src/fontmap.h,v 1.11 2004/08/15 15:37:08 hirata Exp $
    
    This is dvipdfmx, an eXtended version of dvipdfm by Mark A. Wicks.

    Copyright (C) 2002 by Jin-Hwan Cho and Shunsaku Hirata,
    the dvipdfmx project team <dvipdfmx@project.ktug.or.kr>
    
    Copyright (C) 1998, 1999 by Mark A. Wicks <mwicks@kettering.edu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#ifndef _FONTMAP_H_
#define _FONTMAP_H_

#define FONTMAP_RMODE_REPLACE 0
#define FONTMAP_RMODE_APPEND  1
#define FONTMAP_RMODE_REMOVE  2


#define FONTMAP_OPT_REMAP   (1 << 0)
#define FONTMAP_OPT_NOEMBED (1 << 1)
#define FONTMAP_OPT_VERT    (1 << 2)

#define FONTMAP_STYLE_NONE       0
#define FONTMAP_STYLE_BOLD       1
#define FONTMAP_STYLE_ITALIC     2
#define FONTMAP_STYLE_BOLDITALIC 3

typedef struct fontmap_opt {
  double slant, extend;
  double bold;
  long   mapc;
  long   flags;

  char  *otl_tags;

  /* CIDFont option */
  char  *charcoll;
  int    index;
  int    style;
} fontmap_opt;

extern void fontmap_set_verbose (void);

extern void fontmap_read_mapfile (const char *filename, int mode);
extern int  fontmap_add_mapline  (char *mline, char *endptr, int mode);
extern int  fontmap_add_maprec   (const char *tex_name,
				  char *mdef, char *endptr, int mode);

extern void release_map_record (void);
extern int  fontmap_get_map_record (const char *tex_name, int *subfont_id);

extern fontmap_opt *fontmap_get_opt (int map_id);

#define read_mapfile(f)     fontmap_read_mapfile((f),FONTMAP_RMODE_REPLASE)
#define get_map_record(n,s) fontmap_get_map_record((n),(s))

/* extern int subfont_locate_font (char *tex_name); */
extern char  *fontmap_tex_name  (int map_id);
extern char  *fontmap_enc_name  (int map_id);
extern char  *fontmap_sfd_name  (int map_id);
extern char  *fontmap_font_name (int map_id);

extern double fontmap_extend (int map_id);
extern double fontmap_slant  (int map_id);
extern double fontmap_bold   (int map_id);
extern int    fontmap_remap  (int map_id);
extern long   fontmap_mapc   (int map_id);

#endif /* _FONTMAP_H_ */
